﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace Ekkoklient {
    class Program {
        private const int PORT = 12000;
        static void Main(string[] args) {
            // Serveradresser og port;
            IPEndPoint adresse = new IPEndPoint(IPAddress.Parse("127.0.0.1"), PORT);
            // Instantiér socket
            Socket server = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            try {
                server.Connect(adresse); // Forbinder socket til server
            } catch(SocketException e) {
                Console.WriteLine("Kan ikke forbinde til server ...\nFejl: {0}", e.Message);
                return; // Dø!
            }
            NetworkStream stream = new NetworkStream(server);
            StreamReader reader = new StreamReader(stream);
            StreamWriter writer = new StreamWriter(stream);
            
            string data = reader.ReadLine(); // Læser velkomst fra server
            Console.WriteLine(data); // Skriver velkomst til skærmen

            string input;
            while((input = Console.ReadLine()) != "q") { // Sålænge der kommunikeres
                writer.WriteLine(input); // Skriver tekst til serveren
                writer.Flush(); // Tømmer tcp-bufferen
                data = reader.ReadLine(); // Læser ekko fra serveren
                Console.WriteLine(data); // Skriver ekko på skærmen
            }
            Console.WriteLine("Forbindelsen til serveren lukkes ned ...\n");
            writer.Close();
            reader.Close();
            stream.Close();
            server.Shutdown(SocketShutdown.Both);
            server.Close();
        }
    }
}
