﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Net;
using System.Net.Sockets;

namespace Ekkoserver {
    class Program {
        private const int PORT = 12000;
        static void Main(string[] args) {
            IPEndPoint port = new IPEndPoint(IPAddress.Any, PORT); // Tillad alle klienter
            // Instantiér serversocket
            Socket server = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            server.Bind(port); // Lad serveren lytte på port
            server.Listen(10); // Tillad 10 ventende klienter
            Console.Write("Server er startet på port {0}. ", port.Port);
            while(true) { // Uendelig server-løkke
                Console.WriteLine("Venter på ny klient ...\n");
                Socket klient = server.Accept(); // Venter på klient ...
                Console.WriteLine("Klient gået i fælden ...\n");

                NetworkStream stream = new NetworkStream(klient);
                StreamReader reader = new StreamReader(stream);
                StreamWriter writer = new StreamWriter(stream);

                string data = "Velkommen til Ekkoserver-test. Skriv en tekst: ";
                writer.WriteLine(data); // Skriver til klient
                writer.Flush(); // Tømmer tcp-bufferen
                while (true) { // Sålænge der kommunikeres med klienten
                    try {
                        data = reader.ReadLine(); // Læser fra klienten
                    }
                    catch (IOException) { // Klienten har lukket forbindelsen
                        break;
                    }
                    Console.WriteLine(data); // Skriver data til skærm
                    writer.WriteLine("ekko> {0}", data); // Sender ekko tilbage til klienten
                    writer.Flush(); // Tømmer tcp-bufferen
                }
                Console.WriteLine("Forbindelsen til klienten lukkes ned ...\n");
                writer.Close();
                reader.Close();
                stream.Close();
            }
        }
    }
}
